"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withDeprecationWarning = exports.padZeroes = exports.getTimeStamp = void 0;

var padZeroes = function padZeroes(width, n) {
  return ('' + n).padStart(width, '0');
};

exports.padZeroes = padZeroes;

var getTimeStamp = function getTimeStamp() {
  var now = new Date();
  return "[".concat(padZeroes(2, now.getHours()), ":").concat(padZeroes(2, now.getMinutes()), ":") + "".concat(padZeroes(2, now.getSeconds()), ".").concat(padZeroes(3, now.getMilliseconds()), "]");
};

exports.getTimeStamp = getTimeStamp;
var shownWarningLabels = [];

var withDeprecationWarning = function withDeprecationWarning(warningLabel, fn) {
  return function () {
    if (!shownWarningLabels.includes(warningLabel)) {
      var message;

      switch (warningLabel) {
        // case constants.DEPRECATED_DEPRECATED_FEATURE:
        //  message = 'DEPRECATED_FEATURE is deprecated, please use FEATURE instead.';
        //  break;
        default:
          message = 'Unspecified warning.';
      } // eslint-disable-next-line no-console


      console.warn("WARNING: react-lifecycle-visualizer: ".concat(message));
      shownWarningLabels.push(warningLabel);
    }

    return fn.apply(void 0, arguments);
  };
};

exports.withDeprecationWarning = withDeprecationWarning;